# -*- coding: iso-8859-1 -*-
"""
Spiele mit Entropie -- braucht mindestens Python 2.3

Vgl. Skript: "Entropie II"
"""

from math import log
import random


def computeEntropy(dist):
	"""returns the entropy of the dictionary-modeled distribution dist.
	"""
	return -sum([p*log(p) for p in dist.itervalues() if p])/log(2)


def normalize(dist):
	"""normalizes a dictionary-modeled distribution in place.
	"""
	norm = float(sum(dist.itervalues()))
	for key in dist.iterkeys():
		dist[key] /= norm
	return dist


def getRandomString(template, length):
	"""returns a random string with length characters consisting of characters 
	distributed as in the template.
	"""
	return "".join([random.choice(template) for i in xrange(length)])


def getDistributionFromSeq(seq):
	"""returns a distribution for the members of seq.
	"""
	itFreq = {}
	for item in seq:
		itFreq[item] = itFreq.get(item, 0)+1
	return normalize(itFreq)


def probB():
	dist = {
		'a': 20,
		'b': 60,
		'c': 80,
	}
	normalize(dist)
	print computeEntropy(dist)


def probD():
	template = "abc"
	#template = ["abc", "acd", "ade"]
	sample = getRandomString(template, 2000)
	print "Template Entropy:", computeEntropy(getDistributionFromSeq(template))
	print "Sample Entropy:", computeEntropy(getDistributionFromSeq(sample))
	open("sample.txt", "w").write(sample)


if __name__=="__main__":
	probB()
#	probD()
